/***************************************************************************
                          QtRubySmokeBinding.cpp  -  description
                             -------------------
    begin                : Fri Jul 4 2003
    copyright            : (C) 2003 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>

#include <qglobal.h>
#include <qstring.h>
#include <qapplication.h>
#include <qmetaobject.h>
#include <private/qucomextra_p.h>

#undef DEBUG
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#ifndef __USE_POSIX
#define __USE_POSIX
#endif
#ifndef __USE_XOPEN
#define __USE_XOPEN
#endif
#ifdef _BOOL
#define HAS_BOOL
#endif

#include <ruby.h>

#ifndef QT_VERSION_STR
#define QT_VERSION_STR "Unknown"
#endif

#undef free
#undef malloc

#include "marshall.h"
#include "qtruby.h"
#include "smokeruby.h"

extern Smoke *qt_Smoke;
extern void init_qt_Smoke();

int do_debug = qtdb_none;

VALUE pointer_map;
VALUE rv_qapp;
int object_count = 0;
void *_current_object = 0;    // TODO: ask myself if this is stupid

bool temporary_virtual_function_success = false;

QAsciiDict<Smoke::Index> methcache(2179);
QAsciiDict<Smoke::Index> classcache(2179);

VALUE rv_this;

Smoke::Index _current_object_class = 0;
Smoke::Index _current_method = 0;

/*
 * Type handling by moc is simple.
 *
 * If the type name matches /^(?:const\s+)?\Q$types\E&?$/, use the
 * static_QUType, where $types is join('|', qw(bool int double char* QString);
 *
 * Everything else is passed as a pointer! There are types which aren't
 * Smoke::tf_ptr but will have to be passed as a pointer. Make sure to keep
 * track of what's what.
 */

/*
 * Simply using typeids isn't enough for signals/slots. It will be possible
 * to declare signals and slots which use arguments which can't all be
 * found in a single smoke object. Instead, we need to store smoke => typeid
 * pairs. We also need additional informatation, such as whether we're passing
 * a pointer to the union element.
 */

enum MocArgumentType {
    xmoc_ptr,
    xmoc_bool,
    xmoc_int,
    xmoc_double,
    xmoc_charstar,
    xmoc_QString
};

struct MocArgument {
    // smoke object and associated typeid
    SmokeType st;
    MocArgumentType argType;
};


extern TypeHandler Qt_handlers[];
void install_handlers(TypeHandler *);

VALUE getPointerObject(void *ptr) {
//    HV *hv = pointer_map;
//    SV *keysv = newSViv((IV)ptr);
//   STRLEN len;
//    char *key = SvPV(keysv, len);
//    SV **svp = hv_fetch(hv, key, len, 0);
//    SvREFCNT_dec(keysv);
//    if(!svp) return 0;
//    return *svp;
}

void unmapPointer(smokeruby_object *o, Smoke::Index classId, void *lastptr) {
//    HV *hv = pointer_map;
//    void *ptr = o->smoke->cast(o->ptr, o->classId, classId);
//    if(ptr != lastptr) {
//	lastptr = ptr;
//	SV *keysv = newSViv((IV)ptr);
//	STRLEN len;
//	char *key = SvPV(keysv, len);
//	if(hv_exists(hv, key, len))
//	    hv_delete(hv, key, len, G_DISCARD);
//	SvREFCNT_dec(keysv);
//    }
//    for(Smoke::Index *i = o->smoke->inheritanceList + o->smoke->classes[classId].parents;
//	*i;
//	i++) {
//	unmapPointer(o, *i, lastptr);
//    }
}

// Store pointer in pointer_map hash : "pointer_to_Qt_object" => weak ref to associated Perl object
// Recurse to store it also as casted to its parent classes.

void mapPointer(VALUE obj, smokeruby_object *o, VALUE hv, Smoke::Index classId, void *lastptr) {
//    void *ptr = o->smoke->cast(o->ptr, o->classId, classId);
//    if(ptr != lastptr) {
//	lastptr = ptr;
//	SV *keysv = newSViv((IV)ptr);
//	STRLEN len;
//	char *key = SvPV(keysv, len);
//	SV *rv = newSVsv(obj);
//	sv_rvweaken(rv);		// weak reference!
//	hv_store(hv, key, len, rv, 0);
//	SvREFCNT_dec(keysv);
//    }
//    for(Smoke::Index *i = o->smoke->inheritanceList + o->smoke->classes[classId].parents;
//	*i;
//	i++) {
//	mapPointer(obj, o, hv, *i, lastptr);
//    }
}

class QtRubySmokeBinding : public SmokeBinding {
public:
	QtRubySmokeBinding(Smoke * smokePtr);
    void deleted(Smoke::Index classId, void *obj);
    bool callMethod(Smoke::Index method, void *obj, Smoke::Stack args, bool isAbstract = false);
    char* className(Smoke::Index classId);
	~QtRubySmokeBinding();

};

QtRubySmokeBinding::QtRubySmokeBinding(Smoke * smokePtr) :
	SmokeBinding(smokePtr)
{
}

void
QtRubySmokeBinding::deleted(Smoke::Index classId, void *obj)
{
	return;
}

bool
QtRubySmokeBinding::callMethod(Smoke::Index method, void *obj, Smoke::Stack args, bool isAbstract)
{
	return 0;
}

char*
QtRubySmokeBinding::className(Smoke::Index classId)
{
	return 0;
}

QtRubySmokeBinding::~QtRubySmokeBinding()
{
}

VALUE
ruby_this()
{
    return rv_this;
}

VALUE
app()
{
    return rv_qapp;
}

VALUE
version()
{
    return rb_str_new2(QT_VERSION_STR);
}

VALUE cTest;

static VALUE t_method_missing(int argc, VALUE * argv, VALUE self)
{
	printf("In t_method_missing(argc: %d, argv[0]: %s argv[1]: %d)\n",
			argc,
			rb_id2name( SYM2ID(argv[0]) ),
			NUM2INT(argv[1]) );
	return self;
}

void
Init_Qt()
{
    init_qt_Smoke();
    qt_Smoke->binding = new QtRubySmokeBinding(qt_Smoke);
    install_handlers(Qt_handlers);

	ruby_init();
    cTest = rb_define_class("Qt", rb_cObject);
    rb_define_method(cTest, "method_missing", t_method_missing, -1);

	pointer_map = rb_ary_new();
	rb_gc_register_address(&pointer_map);
//	rv_this = ??;
//	rb_gc_register_address(&rv_this);

	rb_eval_string("x = Qt.new");
	rb_eval_string("x.foobar(3)");
	
    methcache.setAutoDelete(1);
    classcache.setAutoDelete(1);
}

